package org.bitbucket.bradleysmithllc.webserviceshubclient.parameter;

import java.io.PrintWriter;

public class ParameterImpl implements Parameter
{
	private final String parameterName;
	private final String parameterValue;
	private final String mappletName;

	public ParameterImpl(String mappletName, String parameterName, String parameterValue)
	{
		this.parameterName = parameterName;
		this.parameterValue = parameterValue;
		this.mappletName = mappletName;
	}

	public String getParameterValue()
	{
		return parameterValue;
	}

	@Override
	public String getQualifiedParameterName() {
		return getMappletName() == null ? getParameterName() : ((getMappletName() + ".") + getParameterName());
	}

	public String getParameterName()
	{
		return parameterName;
	}

	public String getMappletName()
	{
		return mappletName;
	}

	public void write(PrintWriter output)
	{
		output.println(asString());
	}

	public String asString()
	{
		return new StringBuilder().append(getQualifiedParameterName()).append("=").append(getParameterValue()).toString();
	}

	@Override
	public String toString() {
		return "ParameterImpl{" +
				"parameterName='" + parameterName + '\'' +
				", parameterValue='" + parameterValue + '\'' +
				", mappletName=" + (mappletName == null ? "null" : ("'" + mappletName + "'"))  +
				'}';
	}

	@Override
	public int compareTo(Parameter o) {
		String oMappletName = o.getMappletName();
		String mappletName = getMappletName();

		if (oMappletName != null && mappletName != null)
		{
			int mres = oMappletName.compareTo(mappletName);

			if (mres != 0)
			{
				return mres;
			}
		}
		else if (mappletName != null)
		{
			return -1;
		}
		else if (oMappletName != null)
		{
			return 1;
		}

			int pres = parameterName.compareTo(o.getParameterName());

		if (pres == 0)
		{
			return parameterValue.compareTo(o.getParameterValue());
		}

		return pres;
	}
}